package com.engidea.winjcom;

import com.engidea.winjcom.exception.UnsupportedCommOperationException;

import java.io.*;

/**
 * Mostly as from standard...
 */
public abstract class CommPort 
  {
  protected final String portName;
  
  public CommPort ( String portName )
    {
    this.portName = portName;
    }
    
  public String getName()
    {
    return portName;
    }

  public abstract void enableReceiveFraming(int f) throws UnsupportedCommOperationException;

  public abstract void disableReceiveFraming();

  public abstract boolean isReceiveFramingEnabled();

  public abstract int getReceiveFramingByte();

  public abstract void disableReceiveTimeout();

  public abstract void enableReceiveTimeout(int timeoutMilli) throws UnsupportedCommOperationException;

  public abstract boolean isReceiveTimeoutEnabled();

  public abstract int getReceiveTimeout();

  public abstract void enableReceiveThreshold(int thresh) throws UnsupportedCommOperationException;

  public abstract void disableReceiveThreshold();

  public abstract int getReceiveThreshold();

  public abstract boolean isReceiveThresholdEnabled();

  public abstract void setInputBufferSize(int size);

  public abstract int getInputBufferSize();

  public abstract void setOutputBufferSize(int size);

  public abstract int getOutputBufferSize();

  public abstract InputStream getInputStream() throws IOException;

  public abstract OutputStream getOutputStream() throws IOException;

  public abstract void open() throws IOException;
  
  public abstract void close();


  public String toString()
    {
    return portName;
    }
  }
