package com.engidea.winjcom;

import java.util.*;

public class SerialPortEvent extends EventObject
  {
  public static final int DATA_AVAILABLE = 1;
  public static final int OUTPUT_BUFFER_EMPTY = 2;
  public static final int CTS = 3;
  public static final int DSR = 4;
  public static final int RI = 5;
  public static final int CD = 6;
  public static final int OE = 7;
  public static final int PE = 8;
  public static final int FE = 9;
  public static final int BI = 10;

  private boolean newValue;
  private int eventType;

  public SerialPortEvent( SerialPort srcport, int eventtype, boolean oldvalue, boolean newvalue)
    {
    super(srcport);
    this.newValue = newvalue;
    this.eventType = eventtype;
    }

  public int getEventType()
    {
    return (eventType);
    }

  public boolean getNewValue()
    {
    return newValue;
    }

  public boolean getOldValue()
    {
    throw new IllegalStateException("Not supported yet");
    }
    
  public String getEventTypeString ()
    {
    switch ( eventType )  
      {
      case DATA_AVAILABLE: return "RxData";
      case OUTPUT_BUFFER_EMPTY: return "TxEmpty";
      case CTS: return "CTS";
      case DSR: return "DSR";
      case RI:  return "RI";
      case CD:  return "CD";
      case OE:  return "OE";
      case PE:  return "PE";
      case FE:  return "FE";
      case BI:  return "BI";
      default:  return "Unknown";
      }
    }
    
  public String toString()
    {
    return getEventTypeString()+"("+newValue+")";
    }
  }
